https://leetcode-cn.com/problems/target-sum/
非常推荐去阅读labuladong算法小抄中的章节,详细有条理https://labuladong.gitbook.io/algo/dong-tai-gui-hua-xi-lie/targetsum
直接穷举每个状态,但是复杂度为指数级
class Solution { public int findTargetSumWays(int[] nums, int S) { return count(nums, 0, S); } private int count(int[] nums, int index, int cur) { if (index == nums.length) { return cur == 0 ? 1 : 0; } return count(nums, index + 1, cur + nums[index]) + count(nums, index + 1, cur - nums[index]); } }转变以下问题思路 1.在非负数组nums中分配加号减号,使和为target 则sum(+) + sum(-) = sum(nums); (sum(+)表示分配+号的数的和,sum(-)表示分配-号的数的和) sum(+) - sum(-) = target; 2 * sum(+) = target + sum(nums); sum(+) = (target + sum(nums)) / 2
2.因此,原题可转化为,给定一个数target,在非负数组中挑选几个数,使他们的和为target,计算有多少种选取方式。恰好是个经典的背包问题。 而且我们从暴力法也可以得知,当前状态只与目前遍历的下标以及目前的和有关,因此dp[i][j]表示在选定前i个元素,和为j的选取数。 方程推导等同于背包问题,具体看代码就好。需要详细过程的可以去看推荐的那个。
class Solution { public int findTargetSumWays(int[] nums, int S) { int sum = 0; for (int i : nums) { sum += i; } if (sum < S || (S + sum) % 2 == 1) { return 0; } return count(nums, (S + sum) / 2); } private int count(int[] nums, int target) { int n = nums.length; int[][] dp = new int[n + 1][target + 1]; for (int i = 0; i <= n; i++) { dp[i][0] = 1; } for (int i = 1; i <= n; i++) { for (int j = 0; j <= target; j++) { if (j >= nums[i - 1]) { dp[i][j] = dp[i - 1][j - nums[i - 1]] + dp[i - 1][j]; } else { dp[i][j] = dp[i - 1][j]; } } } return dp[n][target]; } }当前状态只与前一行有关,用矩阵压缩来优化一下
class Solution { public int findTargetSumWays(int[] nums, int S) { int sum = 0; for (int i : nums) { sum += i; } if (sum < S || (S + sum) % 2 == 1) { return 0; } return count(nums, (S + sum) / 2); } private int count(int[] nums, int target) { int n = nums.length; int[] dp = new int[target + 1]; dp[0] = 1; for (int i = 1; i <= n; i++) { for (int j = target; j >= 0; j--) { if (j >= nums[i - 1]) { dp[j] += dp[j - nums[i - 1]]; } } } return dp[target]; } }